# -*- coding: utf-8 -*-
from setuphelpers import *

uninstallkey = []


def install():
    if not isdir("/Applications/ldapadmin.app/Contents/MacOS"):
        mkdirs("/Applications/ldapadmin.app/Contents/MacOS")
    filecopyto("LdapAdmin", "/Applications/ldapadmin.app/Contents/MacOS/LdapAdmin")
    run("chmod 755 /Applications/ldapadmin.app/Contents/MacOS/LdapAdmin")
    with open("/Applications/ldapadmin.app/Contents/Info.plist", "w") as f:
        f.write(info_plist % control.get_software_version())


def uninstall():
    if isdir("/Applications/ldapadmin.app"):
        remove_tree("/Applications/ldapadmin.app")


def audit():
    if not isfile("/Applications/ldapadmin.app/Contents/MacOS/LdapAdmin"):
        print("erreur file not found")
        return "ERROR"
    else:
        return "OK"


def update_package():

    wget(
        "http://srvtemplates.ad.tranquil.it/binary_cache/windres",
        "/usr/local/bin/windres",
        sha256="035d0036e0968c4b21fe180b1938694baaf3cb78b8a0c146559e6d8fbedb7e06",
    )
    run("chown root:wheel /usr/local/bin/windres")
    run("chmod 755 /usr/local/bin/windres")

    # Compile
    mkdirs("/var/build")
    run("git clone https://github.com/ibv/LDAP-Admin.git /var/build")

    version = "0.0.%s" % run(r"git -C /var/build rev-list --count master").strip()
    control.version = "%s-%s" % (version, control.version.split("-", 1)[-1])
    control.save_control_to_wapt()

    run("/Applications/Lazarus/lazbuild /var/build/Source/LdapAdmin.lpi --ws=cocoa --build-mode=Macos")

    # WAPT PAckage prepare
    filecopyto("/var/build/Source/LdapAdmin", "LdapAdmin")


info_plist = r"""<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
<plist version="1.0">
<dict>
    <key>CFBundleName</key>
    <string>LdapAdmin</string>
        <key>CFBundleShortVersionString</key>
    <string>%s</string>
    <key>CFBundleExecutable</key>
    <string>LdapAdmin</string>
    <key>CFBundleIconFile</key>
    <string>icon.icns</string>
    <key>CFBundleIdentifier</key>
    <string>it.tranquil.ldapadmin</string>
    <key>NSHighResolutionCapable</key>
    <true/>
    <key>LSUIElement</key>
    <true/>
</dict>
</plist>"""
